with Interfaces; use Interfaces;

package body CosNotifyChannelAdmin_SupplierAdmin_Hash is

   P : constant array (0 .. 5) of Natural :=
     (1, 4, 5, 8, 11, 23);

   T1 : constant array (0 .. 5) of Unsigned_8 :=
     (32, 19, 26, 22, 14, 2);

   T2 : constant array (0 .. 5) of Unsigned_8 :=
     (13, 21, 23, 21, 2, 4);

   G : constant array (0 .. 50) of Unsigned_8 :=
     (0, 14, 13, 16, 0, 18, 0, 24, 23, 14, 0, 0, 0, 0, 10, 0, 0, 15, 22, 0,
      12, 0, 0, 20, 23, 0, 0, 14, 10, 0, 0, 13, 19, 0, 8, 0, 0, 4, 0, 0, 4,
      0, 8, 12, 0, 0, 0, 0, 9, 17, 0);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 51;
         F2 := (F2 + Natural (T2 (K)) * J) mod 51;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 25;
   end Hash;

end CosNotifyChannelAdmin_SupplierAdmin_Hash;
